%define name scilab 
%define version 4.1.1
%define release %mkrel 1

%define flavor emacs

Summary: A high-level language for numerical computations
Name: %name
Version: %version
Release: %release
License: SCILAB
Group: Sciences/Mathematics
# CAUTION: pristine source is actually tar.gzipped
Source0: http://www.scilab.org/download/stable/%{name}-%{version}-src.tar.gz
Source20: scilab.el
URL: http://www.scilab.org/
BuildRequires: perl tcl-devel tk-devel Xaw3d-devel vte-devel 
BuildRequires: emacs-nox libgcj-devel gcc3.3-g77
BuildRequires: gcc-java ocaml
BuildRequires: ImageMagick sablotron
Requires: tcl tk gcc-gfortran
BuildRoot: %{_tmppath}/%name-buildroot
Excludearch: sparc ia64

%description
Scilab is a high-level language, primarily intended for numerical
computations.  Scilab includes a number of toolboxes and on-line
documentation.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q 

%build
%__libtoolize --copy --force
export CFLAGS="$RPM_OPT_FLAGS"
export CC_OPTIONS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"
export FFLAGS="$RPM_OPT_FLAGS"
export FC_OPTIONS="$RPM_OPT_FLAGS"
rm -f config.cache
# ignore java include check
perl -pi -e "s/JAVASCITARGET=javasci-bidon/JAVASCITARGET=scilex-lib/" m4/java.m4
autoconf
%configure --enable-shared --with-g77 --with-java --enable-static=no --with-xaw3d --with-tk

# fix java include path
perl -pi -e "s/JAVAINC=.*/JAVAINC=/" routines/Javasci/Makefile

#make FC_OPTIONS="$RPM_OPT_FLAGS" CC_OPTIONS="$RPM_OPT_FLAGS" all
make all
make tarbindist 2>&1 > /dev/null

cp -af %SOURCE20 .
for i in %{flavor};do
	$i -batch -q -no-site-file -f batch-byte-compile %{name}.el
	mv %{name}.elc $i-%{name}.elc
done



%install
rm -rf $RPM_BUILD_ROOT
#makeinstall

mkdir -p $RPM_BUILD_ROOT{%_libdir,%_bindir}
pushd $RPM_BUILD_ROOT%_libdir
   tar xf $RPM_BUILD_DIR/scilab-%{version}/scilab-4.*-bin.tar
popd

# Nuke dependencies on /bin/SCILABGS and /bin/sh5
pushd $RPM_BUILD_ROOT%_libdir/scilab-*
    chmod -x ./scripts/scilab.g
    perl -pi -e s+/bin/sh5+/bin/sh+ ./bin/dold
popd

# Nuke attempts to setenv SCI from build directory.
pushd $RPM_BUILD_ROOT%_libdir/scilab-*
  for F in `grep -l ${RPM_BUILD_DIR} ./util/* ./bin/*`
  do
    perl -pi -e "s+${RPM_BUILD_DIR}+%{_libdir}+" ${F}
  done
popd

# Add /usr/bin/scilab symlink
ln -s %_libdir/%name-%version/bin/scilab $RPM_BUILD_ROOT%_bindir/scilab

# Clean up some perms stuff so we don't get bogus dependencies
chmod a-x `find $RPM_BUILD_ROOT%_libdir/scilab-*/ -type f -name "Makefile.*"`

# Icons
install -d $RPM_BUILD_ROOT/%{_miconsdir}
install -d $RPM_BUILD_ROOT/%{_liconsdir}
convert X11_defaults/%{name}.xpm -geometry 48x48 %{buildroot}%{_liconsdir}/%{name}.png
convert X11_defaults/%{name}.xpm -geometry 32x32 %{buildroot}%{_iconsdir}/%{name}.png
convert X11_defaults/%{name}.xpm -geometry 16x16 %{buildroot}%{_miconsdir}/%{name}.png

mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/pclinuxos-%{name}.desktop << EOF
[Desktop Entry]
Name=Scilab
Comment=High-level language for numerical computations
Exec=scilab
Icon=scilab
Terminal=false
Type=Application
Categories=X-MandrivaLinux-MoreApplications-Sciences-Mathematics;
EOF


# (X)emacs
for i in %{flavor};do
	mkdir -p %{buildroot}%{_datadir}/$i/site-lisp/
	mkdir -p %{buildroot}%{_datadir}/emacs/site-lisp/
	install -m644 $i-%{name}.elc %{buildroot}%{_datadir}/$i/site-lisp/
	[[ $i = emacs ]] && install -m644 %{name}.el %{buildroot}%{_datadir}/emacs/site-lisp/
done

mkdir -p %buildroot%{_sysconfdir}/emacs/site-start.d
install -m644 %{SOURCE20} %buildroot%{_sysconfdir}/emacs/site-start.d/%{name}.el

%post
%{update_desktop_database}

%postun
%{clean_desktop_database}

%clean
rm -rf $RPM_BUILD_ROOT
rm -f ../scilab-4.*-bin.tar

%files
%defattr(-,root,root)
%doc ACKNOWLEDGEMENTS CHANGES license.txt licence.txt
%_bindir/*
%_libdir/scilab-*
%{_miconsdir}/%{name}.png
%{_iconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%config(noreplace) /etc/emacs/site-start.d/%{name}.el
%{_datadir}/*/site-lisp/*el*
%_datadir/applications/*

%changelog
* Wed Aug 22 2007 Texstar <texstar@gmail.com> 4.1.1-1pclos2007
- import into pclos 2007 original specfile from Lenny Cartier
- update to 4.1.1
- remove old menu system
